#define _LARGEFILE64_SOURCE
#include <stdio.h>
#include <time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "gen.h"


int apachelog(char *file, struct in_addr addr, time_t when, int statuscode, off64_t size, char *request, char *referer, char *browser)
{
	struct tm *ptm = localtime(&when);
	const char *tzone;
	FILE *fh = fopen(file, "a+");
	if (!fh)
		return -1;

#ifdef _BSD_SOURCE
	tzone = ptm -> tm_zone;
#else
	tzone = "GMT";
#endif

	/* ip - - [DD/MMM/YYYY:HH:MM:SS +0100] "GET/HEAD URL HTTP/1.1" STATUSCODE SIZE "REFERER" "BROWSER" */
	fprintf(fh, "%s - - [%02d/%s/%04d:%02d:%02d:%02d %s] \"%s\" %d %lld \"%s\" \"%s\"\n",
			inet_ntoa(addr),
			ptm -> tm_mday, month[ptm -> tm_mon], ptm -> tm_year + 1900, ptm -> tm_hour, ptm -> tm_min, ptm -> tm_sec,
			tzone,
			request,
			statuscode,
			size,
			referer,
			browser);

	fclose(fh);

	return 0;
}
